VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Class1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Dim conection As ADODB.Connection

Private m_CodigoXML As String
Private m_StatusError As Boolean

Private m_PathBasedato As String

'Evento para el Error
Public Event showError(ByVal ErrNumero As Long, ErrDescripcion As String)


'Conecta a la bd (el password es opcional)
Public Sub Conectar(Optional passWord As String)
  
  On Error GoTo errSub
  Dim Cadena As String
  
  If m_PathBasedato = "" Then
     MsgBox " Se debe especificar una ruta para la base de datos en la propiedad PathBaseDato ", vbInformation, " Error "
  End If
  
  If Not IsMissing(passWord) Then
  
    Cadena = "Provider=Microsoft.Jet.OLEDB.4.0;"
    Cadena = Cadena & "Data Source=" & m_PathBasedato & ";"
    Cadena = Cadena & "Jet OLEDB:Engine Type=5;"
    
    Set conection = New ADODB.Connection
    conection.Open Cadena
  Else
      Cadena = vbNullString
      Cadena = "Provider=Microsoft.Jet.OLEDB.4.0;"
      Cadena = Cadena & "Data Source=" & m_PathBasedato & ";"
      Cadena = Cadena & "Jet OLEDB:Engine Type=5;"
      Cadena = Cadena & passWord
      Set conection = New ADODB.Connection
      
      conection.Open Cadena
  
  End If
    
  Exit Sub

errSub:

      RaiseEvent showError(Err.Number, Err.Description)
      m_StatusError = True
      Class_Terminate
End Sub

Public Sub ObtenerXML()
  
  On Error GoTo errSub
  Dim objCatalogo As ADOX.Catalog
  Dim objTabla   As ADOX.Table
  Dim objIndex  As ADOX.Index
  Dim ObjClave   As ADOX.Key
  Dim ObjColumn      As ADOX.Column
  Dim ObjCampo      As ADODB.Fields
  Dim nCol   As Integer
  
  Dim s As String, i   As Integer, j As Integer, k As Integer
  
  Dim Rst      As ADODB.Recordset
  Dim iField    As Integer
  
  
  m_StatusError = False
  
  
  Screen.MousePointer = vbHourglass
    
  m_CodigoXML = vbNullString

  Set objCatalogo = New ADOX.Catalog
  objCatalogo.ActiveConnection = conection
  
  CrearLinea "<?xml version=""1.0""?>"
  CrearLinea "<!DOCTYPE DATABASE>"
  CrearLinea "<DATABASE NAME=""XMLDB.XML"">"
  
  
  
  Set Rst = New ADODB.Recordset
  
  
  For Each objTabla In objCatalogo.Tables
    
    If objTabla.Type = "TABLE" Then
      
      CrearLinea "<TBL Name=""" & objTabla.Name & """>"
      
      Rst.Open "[" & objTabla.Name & "]", conection
            
      For iField = 0 To Rst.Fields.Count - 1
        
        Set ObjColumn = objTabla.Columns(Rst.Fields(iField).Name)
                
        s = "<FLD Name = """ & ObjColumn.Name & """"
        s = s & " Type = """ & Trim$(LoadResString(ObjColumn.Type)) & """"
        s = s & " Size = """ & IIf(ObjColumn.DefinedSize <> 0 And ObjColumn.Type <> adBoolean, ObjColumn.DefinedSize, "0") & """"
        
        
        If ObjColumn.Properties("AutoIncrement").Value Then
          s = s & " AutoIncrement = ""YES"""
        End If
        If Len(ObjColumn.Properties("Description").Value) > 0 Then
          s = s & " Description = """ & ObjColumn.Properties("Description").Value & """"
        End If
        If Not ObjColumn.Properties("Nullable").Value = False Then
          s = s & " Nullable = ""NO"""
        End If
        If ObjColumn.Properties("Jet OLEDB:Allow Zero Length").Value = True Then
          s = s & " AllowZeroLenght=""" & ObjColumn.Properties("Jet OLEDB:Allow Zero Length").Value & """"
        End If
        s = s & "/>"
        CrearLinea s
      Next iField
                                  
      Rst.Close
            
      For Each objIndex In objTabla.Indexes
        s = "<IDX Table = """ & objTabla.Name & """ Name = """ & objIndex.Name & """"
        s = s & " PrimaryKey=" & IIf(objIndex.PrimaryKey, """YES""", """NO""")
        s = s & " IndexNulls=" & IIf(objIndex.IndexNulls = 0, """YES""", """NO""")
        s = s & " Unique=" & IIf(objIndex.Unique, """YES"">", """NO"">")
        CrearLinea s
        
        If objIndex.Columns.Count = 1 Then
          
          s = "<IDXFLD Name=""" & objIndex.Columns(0).Name & """"
          If objIndex.Columns.Item(0).SortOrder = adSortDescending Then
            s = s & " SortOrder=""DESC"""
          End If
          CrearLinea s & "/>"
        ElseIf objIndex.Columns.Count > 1 Then
          
          For k = 0 To objIndex.Columns.Count - 1
            s = "<IDXFLD Name=""" & objIndex.Columns(k).Name & """"
            If objIndex.Columns.Item(k).SortOrder = adSortDescending Then
              s = s & " SortOrder=""DESC"""
            End If
            CrearLinea s & "/>"
          Next k
        End If
        
        CrearLinea "</IDX>"
  
      Next objIndex
      
      s = vbNullString
      CrearLinea "</TBL>"
            
    End If
    
  Next objTabla
  CrearLinea "</DATABASE>"
  
  Set Rst = Nothing
  Screen.MousePointer = vbDefault
  
  Exit Sub

errSub:
  
  RaiseEvent showError(Err.Number, Err.Description)

  m_StatusError = True

  
  Screen.MousePointer = vbDefault
  Class_Terminate
  Exit Sub
  
End Sub


Private Sub CrearLinea(ByRef CodeLine As String)
m_CodigoXML = m_CodigoXML & CodeLine & vbCrLf
End Sub

Private Sub Class_Terminate()
Desconectar
End Sub

Public Sub Desconectar()
On Error GoTo errSub
  
  If Not (conection Is Nothing) Then
    conection.Close
    Set conection = Nothing
  End If

Exit Sub

errSub:
If Err.Number = 3704 Then Exit Sub
End Sub


'Propiedades
'#############################################

Public Property Get PathBasedato() As String
PathBasedato = m_PathBasedato
End Property

Public Property Let PathBasedato(ByVal vNewValue As String)
m_PathBasedato = vNewValue
End Property

Public Property Get HuboError() As Boolean
HuboError = m_StatusError
End Property

Public Property Get CodigoXML() As String
CodigoXML = m_CodigoXML
End Property

Public Property Let CodigoXML(valor As String)
m_CodigoXML = valor
End Property




